<?php

/**
 * resolucion_detalle actions.
 *
 * @package    cobro_coactivo
 * @subpackage resolucion_detalle
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class resolucion_detalleActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'CBR_RESOLUCION_DET',
        'CBR_RESOLUCION_TIT',
        'CBR_TITULO_MINERO_V',
        'CBR_ACTUALIZA_TITULO_V'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'CBR_RESOLUCION_TIT' =>
        array(
            'id_resolucion_tit' => 'CBR_RESOLUCION_DET'
        ),
        'CBR_TITULO_MINERO_V,LEFT' =>
        array(
            'cod_titulo' => 'CBR_RESOLUCION_TIT'
        ),
        'CBR_ACTUALIZA_TITULO_V,LEFT' =>
        array(
            'cod_titulo' => 'CBR_RESOLUCION_TIT'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'CBR_RESOLUCION_DET' =>
        array(
            'id_resolucion_det' => 'id_resolucion_det',
            'id_resolucion_tit' => 'id_resolucion_tit',
            'fecha_expedicion' => 'fecha_expedicion',
            'no_resolucion' => 'no_resolucion',
            'observaciones' => 'observaciones',
            'fecha_log' => 'fecha_log',
            'usuario_log' => 'usuario_log'
        ),
        'CBR_RESOLUCION_TIT' =>
        array(
            'cod_titulo' => 'cod_titulo',
            'id_concepto_resol' => 'id_concepto_resol',
            'fecha_expedicion' => 'fecha_expedicion_tit',
            'no_resolucion' => 'no_resolucion_tit',
            'id_entidad_expide' => 'id_entidad_expide',
            'titulo_vigente' => 'titulo_vigente'
        ),
        'CBR_TITULO_MINERO_V' =>
        array(
            'mineral' => 'mineral_deb',
            'id_debito' => 'id_debito',
            'id_mineral' => 'id_mineral_deb'
        ),
        'CBR_ACTUALIZA_TITULO_V' =>
        array(
            'mineral' => 'mineral',
            'id_mineral' => 'id_mineral',
            'cod_mineral' => 'cod_mineral'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
        'cod_titulo', 'no_resolucion', 'fecha_expedicion'
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     * IN - where de in de oracle, para numero
     * INTEXT - where de in de oracle, para texto
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'CBR_RESOLUCION_DET' =>
        array(
            'id_resolucion_det,a' => array('!=' => array(-1)),
            'id_resolucion_det,b' => array('=' => array('id_resolucion_det')),
            'id_resolucion_tit' => array('=' => array('id_resolucion_tit')),
            'no_resolucion' => array('=' => array('no_resolucion')),
            'fecha_expedicion' => array('BETWEENFECHA' => array('fecha_ini', 'fecha_fin')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(); // filtros de condicion or
    /*
     * Variable manejo de log
     */
//true - consulta de menu administracion
    protected $is_admin = true;
//si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
//true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_resolucion_det'; //identificador de la tabla
    protected $id_names = array('id_resolucion_det'); //llave primaria
    protected $field_names = array('id_resolucion_tit', 'fecha_expedicion', 'no_resolucion',
        'observaciones', 'usuario_log'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CBR_RESOLUCION_DET'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_resolucion_det'; //identificador unico de la tabla

    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            //Campos de log - 20200221
            $request['usuario_log'] = $request['id_username'];
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateRemove(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

}
